import { system,ItemTypes, world, MinecraftBlockTypes,MinecraftEntityTypes, MolangVariableMap, ItemStack, DynamicPropertiesDefinition,PropertyRegistry } from '@minecraft/server';
system.events.beforeWatchdogTerminate.subscribe((event) => {
  event.cancel = true;
});
var dynPropDefx = new DynamicPropertiesDefinition().defineNumber("save_x");
var dynPropDefy = new DynamicPropertiesDefinition().defineNumber("save_y");
var dynPropDefz = new DynamicPropertiesDefinition().defineNumber("save_z");

const scbd =world.scoreboard;
//const stack = new ItemStack("nb:baubles");
var start = true;
var eId;
var xId;
var yId;
var zId;
var bc;

const tag_bracelets = new Array("copper_bracelets","bracelets","gold_bracelets");
const resistance_half= ["hat","copper_hat","diamond_necklace","earrings"];
const resistance = ["iron_hat","diamond_ring","diamond_earrings"];
const resistance_with_half =["gold_diamond_earrings","gold_hat"];
const village_hero= ["emerald_ring","necklace","iron_emerald_earrings"];
const haste_half = ["emerald_earrings","amethyst_ring", "amethyst_necklace", "gold_diamond_earrings"];
const healing=["white_hat","t_shirt","iron_multigem_earrings","multigem_ring","multigem_necklace","multigem_earrings"];
const antiexplosion =["iron_amethyst_earrings", "cap", "long_hat"];

const hat = ["nb:copper_hat","nb:gold_hat","nb:iron_hat","nb:long_hat","nb:hat","nb:white_hat", "nb:cap"];
const bracelets =["nb:bracelets","nb:gold_bracelets","nb:copper_bracelets"];
const ring =["nb:ring","nb:amethyst_ring","nb:multigem_ring","nb:emerald_ring","nb:diamond_ring"];
const earrings =["nb:earrings","nb:multigem_earrings","nb:diamond_earrings","nb:emerald_earrings","nb:iron_amethyst_earrings","nb:iron_multigem_earrings","nb:gold_diamond_earrings","nb:iron_emerald_earrings"];
const underwear =["nb:t_shirt","nb:stone_t_shirt","nb:grass_t_shirt","nb:chainmail","nb:sport_jacket","nb:fireproof_jacket"];
const necklace =["nb:necklace","nb:multigem_necklace","nb:diamond_necklace","nb:amethyst_necklace"];
function isInArr(str,A){
let C = false;
A.forEach((O)=>{
C=(!C)?O==str:C;
});
return C;
};

function effectTags(P){
let resist = 0;
let v_hero = 0;
let haste = 0;
P.getTags().forEach((tag)=>{
if (isInArr(tag, resistance_half)){resist+=0.25};
if (isInArr(tag, resistance)){resist+=0.5};
if (isInArr(tag, resistance_with_half)){resist+=0.75};
if (isInArr(tag, haste_half)){haste+=0.25};
if (isInArr(tag, village_hero)){v_hero+=1};
});
if (haste>0.25){P.runCommandAsync("effect @s haste 16 0 true")};
if (v_hero){P.runCommandAsync("effect @s village_hero 16 "+String(v_hero-1)+" true")};
if (resist){P.runCommandAsync("effect @s resistance 16 "+String(Math.trunc(resist-0.25))+" true")};
};

function tagItemAdd(P,cont){
P.getTags().forEach((tag)=>{
let i = "nb:"+tag;
if (isInArr(i,hat)) {
cont.setItem(0,new ItemStack(i));
};
if (isInArr(i,earrings)) {
cont.setItem(1,new ItemStack(i));
};
if (isInArr(i,necklace)) {
cont.setItem(2,new ItemStack(i));
};
if (isInArr(i,underwear)) {
cont.setItem(3,new ItemStack(i));
};
if (isInArr(i,ring)) {
cont.setItem(4,new ItemStack(i));
};
if (isInArr(i,bracelets)) {
cont.setItem(5,new ItemStack(i));
};
})
};

world.afterEvents.worldInitialize.subscribe(async(event) => {
world.sendMessage('§cThank you for using my addon! To know more about baubles and baubles effects, write "nb help" in the chat');
});

world.afterEvents.entityHurt.subscribe(async(event)=>{
let damage = event.damage;
let hEntity = event.hurtEntity;
let cause = event.damageSource.cause;
let k=0;
let k1=0;
for (let x in healing){
	if (hEntity.hasTag(x)){
		k+=1;
	};
};
for (let i in antiexplosion){
	if (hEntity.hasTag(i)){
		k1+=1;
	};
};
if (k*3 > Math.random()*100 && hEntity.typeId== "minecraft:player"){
	let health = hEntity.getComponent("health");
	health.setCurrent(health.current+damage+k);
};
if (hEntity.typeId== "minecraft:player" && k1*25> Math.random()*100 && cause == "explosion"){
	let health = hEntity.getComponent("health");
	health.setCurrent(health.current+damage);
	};
if (hEntity.typeId== "minecraft:player" && hEntity.hasTag("chainmail") && cause == "projectile"){
	let health = hEntity.getComponent("health");
	health.setCurrent(health.current+Math.round(damage/2));
	};
});
world.afterEvents.playerJoin.subscribe(async(event)=>{
	start=true
});
world.afterEvents.chatSend.subscribe(async(event)=>{
	let word =event.message;
	let P = event.sender;
	if (!event.sendToTargets && word.startsWith("nb ")){
		switch(word.slice(3)){
			case "help":
			case "h":
			case "?":
				world.sendMessage("§eTo get baubles open baubles bags");
				world.sendMessage("§eAll available commands are:");
				world.sendMessage('"nb check baubles"§g - Writes in chat what effects equipped baubles give');
				world.sendMessage('"nb info"§g - Writes link to Mcpedl');
				break;
			case "check baubles":
				for (const tag of P.getTags()){
					var rawMessage = {
						translate: "item.nb:"+tag+".name"};
					if (isInArr(tag,healing)){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Sometimes heals on being hurted");
					};
					if (isInArr(tag,tag_bracelets)){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Sometimes deals addictive damage ");
					};
					if (isInArr(tag, resistance)){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Resistance");
					};
					if (isInArr(tag,resistance_half)){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Some resistance");
					};
					if (isInArr(tag,resistance_with_half)){
						world.sendMessage(rawMessage);
						world.sendMessage("§7A lot of resistance");
					};
					if (isInArr(tag,antiexplosion)){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Chance to have no damage from explode");
					};
					if (isInArr(tag, village_hero)){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Village hero");
					};
					if (isInArr(tag, haste_half)){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Some haste");
					};
					if (tag ==="sport_jacket"){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Let you speeding up on sprinting");
					};
					if (tag ==="fireproof_jacket"){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Extinguish fire on you");
					};
					if (tag =="stone_t_shirt" || tag =="dirt_t_shirt"){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Try to hit dirt or stone");
					};
					if (tag ==="chainmail"){
						world.sendMessage(rawMessage);
						world.sendMessage("§7Let you feel only half of damage by projectiles");
					};
				};
			break;
		case "info":
			world.sendMessage("mcpedl.com/nameless-baubles/");
			break;
		default:
			world.sendMessage('§cThere is no such command. Try to write "nb help" to watch a list of available commands')
			break;
		};
	};
});

world.afterEvents.entityHit.subscribe(async(event) => {
let P = event.entity;
let block = event.hitBlock;
if (block){
	if (block.typeId == "minecraft:dirt" && P.hasTag("grass_t_shirt")) {
		block.setType(MinecraftBlockTypes.get("minecraft:grass"));
	};
	if (block.typeId == "minecraft:stone" && P.hasTag("stone_t_shirt")) {
		block.setType(MinecraftBlockTypes.get("minecraft:cobblestone"));
	};
};
if (event.hitEntity !== undefined && P.typeId == "minecraft:player" && (P.hasTag("bracelets") || P.hasTag("gold_bracelets") || P.hasTag("copper_bracelets"))){
	let koefff;
	let str1;
	if (P.hasTag("bracelets")) {
		koefff=1.75;
		str1 ="particle nb:iron_hit ~ ~"+String(event.hitEntity.getHeadLocation().y - event.hitEntity.location.y) +" ~";
};
	if (P.hasTag("gold_bracelets")) {
		koefff=2.5;
		str1 = "particle nb:gold_hit ~ ~"+String(event.hitEntity.getHeadLocation().y - event.hitEntity.location.y) +" ~";
};
	if (P.hasTag("copper_bracelets")) {
		koefff=1;
		str1 = "particle nb:copper_hit ~ ~"+String(event.hitEntity.getHeadLocation().y - event.hitEntity.location.y) +" ~";
};
	let query_rand = 15*koefff > Math.random()*100;
	if (query_rand && event.hitEntity.typeId != "nb:inv_ent"){
		event.hitEntity.runCommand("damage @s 2 entity_attack entity "+P.name);
		event.hitEntity.runCommand(str1);
};
	//let dim = P.dimension;
	//P.dimension.getEntities().forEach((ent1)=>{ent1.applyDamage(1);});
};
});

system.runInterval(async()=>
{
try{
world.getAllPlayers().forEach((pl)=>{
effectTags(pl);
});
}catch(e){world.sendMessage(e)}
},100)



system.runInterval(async(event)=>
 {
    try{world.getAllPlayers().forEach((P) =>
{
	
	let move = P.getComponent("movement");
	
	if (P.hasTag("sport_jacket") && move.current>0.11 && move.current<0.19) {
		if (move.current < 1.5){move.setCurrent(move.current+0.0002)}else{
			move.setCurrent(move.current+0.00005)
		};
	};
	if (P.hasTag("fireproof_jacket") && (P.getComponent("minecraft:onfire")!==undefined)){P.extinguishFire()};
	const query = {type:"nb:inv_ent",closest:1, location:P.location};
	if (start) {P.selectedSlot = 0; start=false;P.runCommand("tag @s remove nbstart");P.runCommand("event entity @e[type=nb:inv_ent, c=1] minecraft:despawn");}else{
	if (P.selectedSlot == 8) 

{
    if (!P.hasTag("nbstart")){
    var baublesEntity = P.dimension.spawnEntity("nb:inv_ent",P.location);
	baublesEntity.nameTag="Baubles";
	tagItemAdd(P,baublesEntity.getComponent("inventory").container);
	eId=baublesEntity.id;
	P.runCommand("tag @s add nbstart");
} else {
    let bEntity = world.getEntity(eId);
	bEntity.runCommandAsync("tp @s "+P.name);
	bc=bEntity.getComponent("inventory").container;
	    
    let item=bc.getItem(0);
    if (item && !(isInArr(item.typeId, hat))){
	    P.dimension.spawnItem(item, {x:P.location.x,y:P.location.y,z:P.location.z});
	    bc.setItem(0,null);};
         
    let item1=bc.getItem(1);
    if (item1 && !(isInArr(item1.typeId, earrings))){
	    P.dimension.spawnItem(item1, {x:P.location.x,y:P.location.y,z:P.location.z});
	    bc.setItem(1,null);};
    let item2=bc.getItem(2);
    if (item2 && !(isInArr(item2.typeId, necklace))){
	    P.dimension.spawnItem(item2, {x:P.location.x,y:P.location.y,z:P.location.z});
	    bc.setItem(2,null);};
    let item3=bc.getItem(3);
    if (item3 && !(isInArr(item3.typeId, underwear))){
	    P.dimension.spawnItem(item3, {x:P.location.x,y:P.location.y,z:P.location.z});
	    bc.setItem(3,null);};
    let item4=bc.getItem(4);
    if (item4 && !(isInArr(item4.typeId, ring))){
	    P.dimension.spawnItem(item4, {x:P.location.x,y:P.location.y,z:P.location.z});
	    bc.setItem(4,null);};
    let item5=bc.getItem(5);
    if (item5 && !(isInArr(item5.typeId, bracelets))){
	    P.dimension.spawnItem(item5, {x:P.location.x,y:P.location.y,z:P.location.z});
	    bc.setItem(5,null);};
	    
};
}else if (P.hasTag("nbstart")){
	P.runCommand("tag @s remove nbstart");
	P.runCommandAsync("function delTags");
	let a1=bc.getItem(0);
	if (a1) {P.runCommandAsync("tag @s add "+a1.typeId.split(":")[1])};
	let a2=bc.getItem(1);
	if (a2) {P.runCommandAsync("tag @s add "+a2.typeId.split(":")[1])};
	let a3=bc.getItem(2);
	if (a3) {P.runCommandAsync("tag @s add "+a3.typeId.split(":")[1])};
	let a4=bc.getItem(3);
	if (a4) {P.runCommandAsync("tag @s add "+a4.typeId.split(":")[1])};
	let a5=bc.getItem(4);
	if (a5) {P.runCommandAsync("tag @s add "+a5.typeId.split(":")[1])};
	let a6=bc.getItem(5);
	if (a6) {P.runCommandAsync("tag @s add "+a6.typeId.split(":")[1])};
	
    world.getEntity(eId).triggerEvent("minecraft:despawn");
};};
    })}catch(e){world.sendMessage(e)};
}, 0);